//+------------------------------------------------------------------+
//|                                                        FrAMA.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//+------------------------------------------------------------------+
#property copyright   "  "
#property link        "http://www.mql5.com"
#property description "Fractal Adaptive Moving Average"
//--- indicator settings
//#property indicator_separate_window
#property indicator_chart_window

#property indicator_buffers 7
#property indicator_plots   2
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrSeaGreen 
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
#property indicator_label1  "V2_line"

#property indicator_type2   DRAW_COLOR_ARROW
#property indicator_color2  clrSlateGray, clrDodgerBlue, clrOrangeRed  
#property indicator_width2  2
#property indicator_label2  "V2_FrAMA color"

//#property indicator_applied_price PRICE_CLOSE
#include <SmoothAlgorithms.mqh> 
CXMA XMA1;

enum Applied_price_ 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
input int  PeriodFrAMA=18;             // FrAMA period
      int  InpShift=0;                 // Indicator's shift
input int    route=2;                  // route
input int    boom=8;                  // boom
input double facc=1.2;                 // flat_acc
//input Applied_price_ IPC=PRICE_CLOSE_;  //  
input Smooth_Method MA_Method1=MODE_JurX; //  
input int  Length1=4;                     //Lenght1
input int  Phase1=70;                     //Phase1
input int  PeriodMom=6;                   //  Momentum 

//--- indicator buffers
double  Line_buff[]; 
double  XMa_buff[];
double  Color_buff[];
double  FrAma_buff[];
double  acc_buff[];
double   _High[];
double   _Low[]; 

int justart, jstart, jmstart;

//------------------------------------------------------------------
void OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,Line_buff,INDICATOR_DATA);
   SetIndexBuffer(1,XMa_buff,INDICATOR_DATA);
   SetIndexBuffer(2,Color_buff,INDICATOR_COLOR_INDEX);
   SetIndexBuffer(3,FrAma_buff,INDICATOR_CALCULATIONS);
   SetIndexBuffer(4,acc_buff,INDICATOR_CALCULATIONS);
   SetIndexBuffer(5,_High,INDICATOR_CALCULATIONS);
   SetIndexBuffer(6,_Low,INDICATOR_CALCULATIONS);
  
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,2*PeriodFrAMA-1);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetInteger(0,PLOT_SHIFT,InpShift);
   PlotIndexSetInteger(1,PLOT_ARROW,159);
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,2*PeriodFrAMA-1);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetInteger(1,PLOT_SHIFT,InpShift);
  
 //PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,2*PeriodFrAMA-1);
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);

   IndicatorSetString(INDICATOR_SHORTNAME,"V2_frama("+string(PeriodFrAMA)+")");
   PlotIndexSetString(0,PLOT_LABEL,"V2_frama("+string(PeriodFrAMA)+")");
  justart=2;
  jstart =2*PeriodFrAMA-1;
  jmstart=jstart+PeriodMom;
  }

//------------------------------------------------------------------
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- check for data
   if(rates_total<2*PeriodFrAMA)
      return(0);
//--- preparing calculation
   int limit, copied;
   static double frama;
   static double llv, hhv, acc;
   static double tm5roc;
   static int trend; 
  // static int clb; 
  // static int oldtrend;
   double Hi1,Hi2,Hi3,Lo1,Lo2,Lo3;
   double N1,N2,N3,D;
   double ALFA, xma_f;  // jmom;
   //double ALFA1;
   double tm5, tm4, tm3,tm2,tm1,tm0; 
   double pct, pcb, pav;
   double price_;  //jurx;
 // static CJurX JuMA1;
 // static CMomentum MOM;


//--- load High
   if(IsStopped()) return(0); //Checking for stop flag
   copied=CopyHigh(_Symbol,_Period,0,rates_total,_High);
   if(copied!=rates_total)
     {
      Print("Can't load High prices.");
      return(0);
     }
//--- load Low
   if(IsStopped()) return(0); //Checking for stop flag
   copied=CopyLow(_Symbol,_Period,0,rates_total,_Low);
   if(copied!=rates_total)
     {
      Print("Can't load Low prices.");
      return(0);
     }
//--- start calculations
   if(prev_calculated==0)
     {
      limit=2*PeriodFrAMA-1;
      jstart=limit;
      //--- fill in indicator array 
      for(int i=0;i<=limit;i++){
        FrAma_buff[i]=price[i];
       price_= price[i];
    //  jurx=JuMA1.JurXSeries (2,prev_calculated,rates_total,0,2,price_, i,false);
    //  FrAmaBuffer[i]=jurx;
      }
     }
   else limit=prev_calculated-1;
//--- main cycle
   for(int i=limit;i<rates_total && !IsStopped();i++)
     {
     price_= price[i];
  //  jurx=JuMA1.JurXSeries (2,prev_calculated,rates_total,0,2,price_, i,false);
      
      Hi1=iHighest(i,PeriodFrAMA);
      Lo1=iLowest(i,PeriodFrAMA);
      Hi2=iHighest(i-PeriodFrAMA,PeriodFrAMA);
      Lo2=iLowest(i-PeriodFrAMA,PeriodFrAMA);
      Hi3=iHighest(i,2*PeriodFrAMA);
      Lo3=iLowest(i,2*PeriodFrAMA);
      N1=(Hi1-Lo1)/PeriodFrAMA;
      N2=(Hi2-Lo2)/PeriodFrAMA;
      N3=(Hi3-Lo3)/(2*PeriodFrAMA);
      D=(log(N1+N2)-log(N3))/log(2.0);
      ALFA =exp(-3.6*(D-1.0));
   
      FrAma_buff[i]=ALFA*price[i]+(1-ALFA)*FrAma_buff[i-1];
    //  FrAma_buff[i]=ALFA*jurx+(1-ALFA)*FrAmaBuffer[i-1];
    //  frama=ALFA*price[i]+(1-ALFA)*FrAmaBuffer[i-1];
     frama=FrAma_buff[i];
        xma_f = XMA1.XMASeries(jstart,prev_calculated,rates_total,MA_Method1,Phase1,Length1,frama,i,false);
     // xma_f = XMA1.XMASeries(jstart,prev_calculated,rates_total,MA_Method1,Phase1,Length1,price_,i,false);
     // jmom=MOM.MomentumSeries(jmstart,prev_calculated,rates_total,PeriodMom,xma_f,i,false);
     // jmom/=(_Point*10);
     Line_buff[i]=xma_f;
     XMa_buff[i] =xma_f;
     
      tm5= XMa_buff[i-5];
      tm4= XMa_buff[i-4];
      tm3= XMa_buff[i-3];
      tm2= XMa_buff[i-2];
      tm1= XMa_buff[i-1];
      tm0= XMa_buff[i];
      pct=MathMax(tm2,tm1); pcb=MathMin(tm2,tm1);  pav=(tm2+tm1)/2;   tm5roc=MathAbs(tm5-tm1);
     
     llv= MathMin(XMa_buff[i],MathMin(XMa_buff[i-1],XMa_buff[i-2]));
     hhv= MathMax(XMa_buff[i],MathMax(XMa_buff[i-1],XMa_buff[i-2])); 
     acc= (2*xma_f -llv - hhv)*10000; 
    
   switch (route) 
           {
      case 1:  {   
           if( tm5>tm4 && tm4>tm3 && tm3>tm2 && tm2<tm1) trend=1; 
           if( tm5<tm4 && tm4<tm3 && tm3<tm2 && tm2>tm1) trend=-1;
           acc_buff[i]= trend; 
           if(MathAbs(acc)<facc)  acc_buff[i]=0.0;  
           break;}    
           
      case 2:  {
           if( tm5roc>boom*_Point){  
           if( tm5>tm4 && tm4>tm3 && tm3>tm2 && tm2<tm1) trend=1; 
           if( tm5<tm4 && tm4<tm3 && tm3<tm2 && tm2>tm1) trend=-1;
           acc_buff[i]= trend;
           }
           else acc_buff[i]= 0.0;
           break;}   
      default:  acc_buff[i]= 0.0;   
           }
    
     }
     
  
  
  if(prev_calculated==0)    limit=jmstart;   
  for(int i=limit; i<rates_total; i++)
    {
     //clb=0;  Color_buff[i]=0;
     if( acc_buff[i]>0 && (XMa_buff[i]> XMa_buff[i-1])) Color_buff[i]=1; 
     else{
     if( acc_buff[i]<0 && (XMa_buff[i]< XMa_buff[i-1])) Color_buff[i]=2;
     else 
     Color_buff[i]=0;
      }
         
     }
     
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Find the highest value in data range                             |
//+------------------------------------------------------------------+
double iHighest(int StartPos,
                int Depth)
  {
   double res;
//--- check for parameters StartPos and Depth
   if(StartPos<0 || StartPos-Depth+1<0 || Depth<0)
     {
      Print("Invalid parameter in function",__FUNCTION__,": StartPos =",StartPos,", Depth = ",Depth);
      return(0.0);
     }
//--- 
   res=_High[StartPos];
   for(int i=StartPos-Depth+1;i<StartPos;i++)
      if(_High[i]>res)
         res=_High[i];
   return(res);
  }
//+------------------------------------------------------------------+
//| Find the lowest value in data range                              |
//+------------------------------------------------------------------+
double iLowest(int StartPos,
               int Depth)
  {
   double res;
//--- check for parameters StartPos and Depth
   if(StartPos<0 || StartPos-Depth+1<0 || Depth<0)
     {
      Print("Invalid parameter in function",__FUNCTION__,": StartPos =",StartPos,", Depth = ",Depth);
      return(0.0);
     }
//--- 
   res=_Low[StartPos];
   for(int i=StartPos-Depth+1;i<StartPos;i++)
      if(_Low[i]<res)
         res=_Low[i];
   return(res);
  }
//+------------------------------------------------------------------+
